#include "pet.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "basics.h"

   void make_noise (pet my_pet) {
      switch (my_pet.kind) {
         case DOG:   printf ("Woof.");
         case FISH:  printf ("Blub.");
            break;
         case CAT:   printf ("Meow.");
            break;
         default:    fprintf (stderr, "Unrecognized pet type %d!", my_pet.kind);
            exit(0);
         }
      }

   void print_info (pet my_pet) {
	switch (my_pet.kind) {
         case (DOG) : 
               {
	       printf ("Dog %s is %d years old, weighs %g pounds, and ",
			my_pet.info.mydog.name,
			my_pet.info.mydog.age,
			my_pet.info.mydog.weight);
               printf ("has %d bones.\n", my_pet.info.mydog.num_bones);
               printf ("After collecting two more, %s has %d bones.",
               	my_pet.info.mydog.name, collect_bones(2, &(my_pet.info.mydog))); 
               printf ("Now %s has %d bones.\n", my_pet.info.mydog.name, my_pet.info.mydog.num_bones);
               break;
               }
         case (FISH) : 
               {
               printf ("The fish is %s", my_pet.info.myfish.color);
               if (my_pet.info.myfish.salt_water)
		printf (" and likes salt water.");
	       else
		printf (" and likes fresh water.");
               break;
               }
         case (CAT) : 
               {
               printf ("Cat %s is %d years old and weighs %g pounds.",
			my_pet.info.mycat.age,
			my_pet.info.mycat.name,
			my_pet.info.mycat.weight);
               break;
               }
         }
         printf ("Noise: ");
	 make_noise (my_pet);
         printf ("\n\n");
      }
   
   int main () {
      pet rover, fred, charlotte;
   
      rover.kind = DOG;
      rover.info.mydog.age = 9;
      strcpy (rover.info.mydog.name, "J.D.'s Beach Bum II");
      rover.info.mydog.weight = 63.2;
      rover.info.mydog.num_bones = 4;
      rover.info.myfish.salt_water = TRUE; /* still legal, but changes the dog's name! */
   
      fred.kind = FISH;
      strcpy(fred.info.myfish.color, "orange");
      fred.info.myfish.salt_water = FALSE;

      charlotte.kind = CAT;
      strcpy(charlotte.info.mycat.name, "Charlotte");
      charlotte.info.mycat.age = 4;
      charlotte.info.mycat.weight = 6.5;

      print_info(rover);
      print_info(fred);
      print_info(charlotte);
      print_info(rover);
         
      return 0;
      }
